#ifndef __VIRBOX_H_
#define __VIRBOX_H_

#if defined(__clang__) || defined (__GNUC__)
    #ifdef __i386__
        #define  VB_API_CALL    __attribute__((__stdcall__))
    #else
        #define VB_API_CALL
    #endif
#elif defined(_MSC_VER)
    #define VB_API_CALL  __stdcall
    #ifndef SDK_EXPORTS
        #ifdef _WIN64
            #pragma comment(lib, "virbox64.lib")
        #else
            #pragma comment(lib, "virbox32.lib")
        #endif // _WIN64
    #endif
#else
    #define VB_API_CALL
#endif

#ifdef __cplusplus
extern "C" {
#endif

    int VB_API_CALL VBProtectBegin(const char *tag);
    int VB_API_CALL VBVirtualizeBegin(const char *tag);
    int VB_API_CALL VBMutateBegin(const char *tag);
    void VB_API_CALL VBProtectEnd(void);
    
    void *VB_API_CALL VBProtectDecrypt(void *dst, const void *src, int size);
    const void* VB_API_CALL VBDecryptData(const void *data, int size);
    
    #define VBDecryptStringA(_X_)   ((char*)VBDecryptData(_X_, sizeof(_X_)))
    #define VBDecryptStringW(_X_)   ((wchar_t*)VBDecryptData(_X_, sizeof(_X_)))

    void VB_API_CALL VBFreeData(const void *data);
    #define VBFreeString(_X_) VBFreeData(_X_)

    
#if defined(__arm__) || defined(__aarch64__)
    #define VBSnippetBegin
#else
    int VB_API_CALL VBSnippetBegin(const char *tag);
#endif

    // return value: 0 - false; other - true
    int VB_API_CALL VBProtectVerifyImage(void);
    int VB_API_CALL VBVirtualizeFunction(const char *tag);
    int VB_API_CALL VBMutateFunction(const char *tag);

#ifdef __cplusplus
}
#endif

#endif  //  !__VIRBOX_H_

